$MOD52

DIS_A	EQU	P1.5		
DIS_B	EQU	P1.4		
DIS_C	EQU	P1.3
DIS_D	EQU	P1.1
DIS_E	EQU	P1.2
DIS_F	EQU	P1.6
DIS_G	EQU	P1.7
DIS1	EQU	P3.3
DIS2	EQU	P3.4                             
DIS3	EQU	P3.5
LDR1	EQU	P3.0
LDR2	EQU	P3.1
BUZZER	EQU	P1.0

	DSEG            ; This is internal data memory
    

	ORG     20H     ; Bit adressable memory
 	BITS:	DS	1
	UP	BIT     BITS.0  
	DWN	BIT	BITS.1
	COUNT:	DS	1
	SPEED:	DS	1
	VALUE_1:	 DS	1
	VALUE_2:	 DS	1
	VALUE_3:	 DS	1
	COUNTER:	DS	1
	STACK:		 DS      1       ; Stack begins here
 	CSEG            ; Code begins here
 

;---------==========----------==========---------=========---------
;              PROCESSOR INTERRUPT AND RESET VECTORS
;---------==========----------==========---------=========---------
 
     	 ORG     00H    		; Reset
        	 JMP     MAIN
 
	ORG 000BH		;Timer Interrupt0
	JMP REFRESH

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;		MAIN PROGRAM
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
MAIN:
	CLR BUZZER
	MOV SPEED,#00H
	MOV COUNT,#00H
	MOV VALUE_1,#00H
	MOV VALUE_2,#00H
	MOV VALUE_3,#00H
	MOV COUNTER,#00H


	CLR DIS1
	CLR DIS2
	CLR DIS3
	
		

	MOV TMOD,#01H		;enable timer0 for scanning
	MOV TL0,#00H
	MOV TH0,#0FDH         
	SETB ET0
	SETB EA
	SETB TR0


	AJMP ZAZA


ASSA:	AJMP ASAA

ZAZA:	SETB LDR1
	JNB LDR1,ASSA

	CALL DELAY
	SETB LDR2
	JNB LDR2,$

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;		UP COUNTER
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
	SETB BUZZER
	INC COUNTER
	MOV R5,COUNTER
DOIT:	MOV A,#10
	CLR C
	SUBB A,R5
	JC ZX1
	JZ AQ1 
	INC VALUE_1
	AJMP CVC
AQ1:	MOV VALUE_2,#01H
	MOV VALUE_1,#00H
	AJMP CVC
ZX1:	MOV A,#20
	CLR C
	SUBB A,R5
	JC ZX2
	JZ AQ2
	INC VALUE_1
	AJMP CVC
AQ2:	MOV VALUE_2,#02H
	MOV VALUE_1,#00H
	AJMP CVC

ZX2:	MOV A,#30
	CLR C
	SUBB A,R5
	JC ZX3
	JZ AQ3
	INC VALUE_1
	AJMP CVC
AQ3:	MOV VALUE_2,#03H
	MOV VALUE_1,#00H
	AJMP CVC	

ZX3:	MOV A,#40
	CLR C
	SUBB A,R5
	JC ZX4
	JZ AQ4
	INC VALUE_1
	AJMP CVC
AQ4:	MOV VALUE_2,#04H
	MOV VALUE_1,#00H
	AJMP CVC
	
ZX4:	MOV A,#50
	CLR C
	SUBB A,R5
	JC ZX5
	JZ AQ5
	INC VALUE_1
	AJMP CVC
AQ5:	MOV VALUE_2,#05H
	MOV VALUE_1,#00H
	AJMP CVC
	
ZX5:	MOV A,#60
	CLR C
	SUBB A,R5
	JC ZX6
	JZ AQ6
	INC VALUE_1
	AJMP CVC
AQ6:	MOV VALUE_2,#06H
	MOV VALUE_1,#00H
	AJMP CVC
	
ZX6:	MOV A,#70
	CLR C
	SUBB A,R5
	JC ZX7
	JZ AQ7
	INC VALUE_1
	AJMP CVC
AQ7:	MOV VALUE_2,#07H
	MOV VALUE_1,#00H
	AJMP CVC
	
ZX7:	MOV A,#80
	CLR C
	SUBB A,R5
	JC ZX8
	JZ AQ8
	INC VALUE_1
	AJMP CVC
AQ8:	MOV VALUE_2,#08H
	MOV VALUE_1,#00H
	AJMP CVC
	
ZX8:	MOV A,#90
	CLR C
	SUBB A,R5
	JC ZX9
	JZ AQ9
	INC VALUE_1
	AJMP CVC
AQ9:	MOV VALUE_2,#09H
	MOV VALUE_1,#00H
	AJMP CVC
	
ZX9:	MOV A,#100
	CLR C
	SUBB A,R5
	JC ZX10
	JZ AQ10
	INC VALUE_1
	AJMP CVC
AQ10:	MOV VALUE_3,#01H
	MOV VALUE_2,#00H
	MOV VALUE_1,#00H
	AJMP CVC	

ZX10:	MOV A,COUNTER
	CLR C
	SUBB A,#100
	JZ AQQ1
	JC ZXX1
	MOV R5,A
	AJMP DOIT
AQQ1:	MOV VALUE_3,#02H
	MOV VALUE_2,#00H
	MOV VALUE_1,#00H
	AJMP CVC

ZXX1:	MOV VALUE_1,#00H
	MOV VALUE_2,#00H
	MOV VALUE_3,#00H
	
CVC:	
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
	CALL DELAY	
	CLR BUZZER
	JB LDR2,$
	AJMP ZAZA
ZAZAA:	JMP ZAZA
ASAA:	SETB LDR2
	JNB LDR2,ZAZAA

	CALL DELAY	
	SETB LDR1
	JNB LDR1,$
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;		DOWN COUNTER
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
	SETB BUZZER
	DEC COUNTER
	MOV R5,COUNTER
	MOV A,R5
	INC A
	CJNE A,#00H,DOIT1
	MOV VALUE_1,#00H
	MOV VALUE_2,#00H
	MOV VALUE_3,#00H
	MOV COUNTER,#00H
	AJMP CVCV
DOIT1:	
	MOV A,#10
	CLR C
	SUBB A,R5
	JC AZX1
	JZ AAQ1 
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG
	MOV VALUE_2,#00H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG:	
	DEC VALUE_1
	AJMP CVCV
AAQ1:	MOV VALUE_2,#01H
	MOV VALUE_1,#00H
	AJMP CVCV
AZX1:	MOV A,#20
	CLR C
	SUBB A,R5
	JC AZX2
	JZ AAQ2
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG1
	MOV VALUE_2,#01H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG1:	
	DEC VALUE_1
	AJMP CVCV
AAQ2:	MOV VALUE_2,#02H
	MOV VALUE_1,#00H
	AJMP CVCV

AZX2:	MOV A,#30
	CLR C
	SUBB A,R5
	JC AZX3
	JZ AAQ3
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG2
	MOV VALUE_2,#02H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG2:	
	DEC VALUE_1
	AJMP CVCV
AAQ3:	MOV VALUE_2,#03H
	MOV VALUE_1,#00H
	AJMP CVCV	

AZX3:	MOV A,#40
	CLR C
	SUBB A,R5
	JC AZX4
	JZ AAQ4
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG3
	MOV VALUE_2,#03H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG3:	
	DEC VALUE_1
	AJMP CVCV
AAQ4:	MOV VALUE_2,#04H
	MOV VALUE_1,#00H
	AJMP CVCV
	
AZX4:	MOV A,#50
	CLR C
	SUBB A,R5
	JC AZX5
	JZ AAQ5
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG4
	MOV VALUE_2,#04H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG4:	
	DEC VALUE_1
	AJMP CVCV
AAQ5:	MOV VALUE_2,#05H
	MOV VALUE_1,#00H
	AJMP CVCV
	
AZX5:	MOV A,#60
	CLR C
	SUBB A,R5
	JC AZX6
	JZ AAQ6
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG5
	MOV VALUE_2,#05H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG5:	
	DEC VALUE_1
	AJMP CVCV
AAQ6:	MOV VALUE_2,#06H
	MOV VALUE_1,#00H
	AJMP CVCV
	
AZX6:	MOV A,#70
	CLR C
	SUBB A,R5
	JC AZX7
	JZ AAQ7
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG6
	MOV VALUE_2,#06H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG6:	
	DEC VALUE_1
	AJMP CVCV
AAQ7:	MOV VALUE_2,#07H
	MOV VALUE_1,#00H
	AJMP CVCV
	
AZX7:	MOV A,#80
	CLR C
	SUBB A,R5
	JC AZX8
	JZ AAQ8
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG7
	MOV VALUE_2,#07H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG7:	
	DEC VALUE_1
	AJMP CVCV
AAQ8:	MOV VALUE_2,#08H
	MOV VALUE_1,#00H
	AJMP CVCV
	
AZX8:	MOV A,#90
	CLR C
	SUBB A,R5
	JC AZX9
	JZ AAQ9
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG8
	MOV VALUE_2,#08H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG8:	
	DEC VALUE_1
	AJMP CVCV
AAQ9:	MOV VALUE_2,#09H
	MOV VALUE_1,#00H
	AJMP CVCV
	
AZX9:	MOV A,#100
	CLR C
	SUBB A,R5
	JC AZX10
	JZ AAQ10
	MOV R6,VALUE_1
	CJNE R6,#00H,GHG9
	MOV VALUE_3,#00H
	MOV VALUE_2,#09H
	MOV VALUE_1,#09H
	AJMP CVCV
GHG9:	
	DEC VALUE_1
	AJMP CVCV
AAQ10:	MOV VALUE_3,#01H
	MOV VALUE_2,#00H
	MOV VALUE_1,#00H
	AJMP CVCV

AZX10:	MOV A,COUNTER
	CLR C
	SUBB A,#100
	JZ AAQQ1
	JC AZXX1
	MOV R5,A
	MOV A,COUNTER
	CJNE A,#199,JKJK
	MOV VALUE_3,#01H
JKJK:
	AJMP DOIT1
AAQQ1:	MOV VALUE_3,#02H
	MOV VALUE_2,#00H
	MOV VALUE_1,#00H
	AJMP CVCV

AZXX1:	MOV VALUE_1,#00H
	MOV VALUE_2,#00H
	MOV VALUE_3,#00H
	
CVCV:	

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
	CALL DELAY	
	CLR BUZZER
	JB LDR1,$
	AJMP ZAZA

		
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
; 	7 SEGMENT DISPLAY
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
DISP:
	MOV R2,SPEED
	CJNE R2,#00H,AAS1
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	SETB DIS_G
	RET
AAS1:	CJNE R2,#01H,AS2
	CLR DIS_B
	CLR DIS_C
	SETB DIS_A
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	SETB DIS_G
	RET
AS2:	CJNE R2,#02H,AS3
	CLR DIS_A
	CLR DIS_B
	CLR DIS_D
	CLR DIS_E
	CLR DIS_G
	SETB DIS_C
	SETB DIS_F
	RET
AS3:	CJNE R2,#03H,AS4
	CLR DIS_A    
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_G
	SETB DIS_E
	SETB DIS_F
	RET
AS4:	CJNE R2,#04H,AS5
	CLR DIS_B
	CLR DIS_C
	CLR DIS_F
	CLR DIS_G
	SETB DIS_A
	SETB DIS_D
	SETB DIS_E
	RET
AS5:	CJNE R2,#05H,AS6
	CLR DIS_A
	CLR DIS_C
	CLR DIS_D
	CLR DIS_F
	CLR DIS_G
	SETB  DIS_B
	SETB DIS_E
	RET
AS6:	CJNE R2,#06H,AS7
	CLR DIS_A
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	SETB DIS_B
	RET
AS7:	CJNE R2,#07H,AS8
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	SETB DIS_D
	SETB DIS_E
	SETB DIS_F
	SETB DIS_G
	RET
AS8:	CJNE R2,#08H,AS9
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_E
	CLR DIS_F
	CLR DIS_G
	RET
AS9:	CJNE R2,#09H,AS10
	CLR DIS_A
	CLR DIS_B
	CLR DIS_C
	CLR DIS_D
	CLR DIS_F
	CLR DIS_G
	SETB DIS_E
	RET
AS10:	MOV SPEED,#00H
	AJMP DISP

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
REFRESH:
	INC COUNT
	MOV R4,COUNT
QA1:	CJNE R4,#01H,QA2
	MOV SPEED,VALUE_1
	SETB DIS1
	CLR DIS2
	CLR DIS3
	CALL DISP 
	AJMP DOWN   
QA2:	CJNE R4,#02H,QA3
	MOV SPEED,VALUE_2
	CLR DIS1
	SETB DIS2
	CLR DIS3
	CALL DISP 
	AJMP DOWN
QA3:	CJNE R4,#03H,QA4
	MOV SPEED,VALUE_3
	CLR DIS1
	CLR DIS2
	SETB DIS3
	CALL DISP 
	AJMP DOWN
QA4:	MOV COUNT,#01H
	MOV R4,COUNT
	AJMP QA1
DOWN:	MOV TL0,#0FFH		;reload the timer for scanning
	MOV TH0,#0F2H
	RETI
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

DELAY:
	MOV R1,#0FFH
RE1:	MOV R2,#5FH
RE:	NOP
	DJNZ R2,RE
	DJNZ R1,RE1
	RET
END